<?php

/**
 * NOTE: You should always use the wp_enqueue_script() and wp_enqueue_style() functions to include
 * javascript and css files.
 */

/**
 * bp_chat_add_js()
 *
 * This function will enqueue the components javascript file, so that you can make
 * use of any javascript you bundle with your component within your interface screens.
 */
function bp_chat_add_js() {
	global $bp;

	wp_enqueue_script( 'jquery' );
	if ( $bp->current_component == $bp->chat->slug )
	{
		wp_enqueue_script( 'bp-chat-js', WP_PLUGIN_URL . '/bp-chat/js/general.js' );
	}
	wp_enqueue_script( 'bp-chat-js2', WP_PLUGIN_URL . '/bp-chat/js/jqDnR.js' );
	wp_enqueue_script( 'bp-chat-js3', WP_PLUGIN_URL . '/bp-chat/js/dimensions.js' );
	wp_enqueue_script( 'bp-chat-js4', WP_PLUGIN_URL . '/bp-chat/js/jqModal.js' );
	wp_enqueue_script( 'bp-chat-js5', WP_PLUGIN_URL . '/bp-chat/js/move_chat.js' );
}
add_action( 'template_redirect', 'bp_chat_add_js', 1 );
add_action( 'admin_menu', 'bp_chat_add_js' );

/**
 * bp_chat_add_structure_css()
 *
 * This function will enqueue structural CSS so that your component will retain interface
 * structure regardless of the theme currently in use. See the notes in the CSS file for more info.
 */
function bp_chat_add_structure_css() {
	/* Enqueue the structure CSS file to give basic positional formatting for your component reglardless of the theme. */
	wp_enqueue_style( 'bp-chat-structure', WP_PLUGIN_URL . '/bp-chat/css/structure.css' );	
	wp_print_styles();
}
add_action( 'wp_head', 'bp_chat_add_structure_css' );

?>
