<?php
/*
 * @package AJAX_Chat
 * @author Sebastian Tschan
 * @copyright (c) Sebastian Tschan
 * @license GNU Affero General Public License
 * @link https://blueimp.net/ajax/
 */

error_reporting(E_ALL);
#ini_set('display_errors', '1');

class CustomAJAXChat extends AJAXChat {
	public $bp_config              = array();
	public $channels               = null;
	public $users                  = null;
	public $channelMap             = null;

	public $loggedin_user_fullname = null;
	public $xml_logout_url         = null;
	public $loggedin_user_id       = null;


	// Returns an associative array containing userName, userID and userRole
	// Returns null if login is invalid
	function getValidLoginUserData() {
        	$customUsers = $this->getCustomUsers();
		
		foreach($customUsers as $key=>$value) {
			if(($value['userName'] == $this->loggedin_user_fullname) && ($value['password'] == $this->loggedin_user_fullname)) {
				$userData = array();
				$userData['userID'] = $key;
				$userData['userName'] = $this->trimUserName($value['userName']);
				$userData['userRole'] = $value['userRole'];
				$userData['profile'] = $value['profile'];
				return $userData;
			}
		}
		// Guest users:
		return $this->getGuestUser();
	}

	// Initialize custom configuration settings
	function initCustomConfig() {
		$this->bp_config['username']           = "<fill me in!!!>";       //This is your database username
		$this->bp_config['password']           = "<fill me in!!!>";       //This is your database password
		$this->bp_config['database']           = "<fill me in!!!>";       //This is your database name
		$this->bp_config['bp_group_table']     = "wp_bp_groups";          //This is the Buddypress group table name: default = wp_bp_groups
		$this->bp_config['wp_users_table']     = "wp_users";              //This is the WPMU user table name: default = wp_users
		$this->bp_config['bp_groups_members']  = "wp_bp_groups_members";  //This is the Buddypress group members table name: wp_bp_groups_members
		$this->bp_config['db']                 = "127.0.0.1";             //This is your database IP address, or domain name

		$this->channels = $this->getCustomChannels();
		$this->channelMap = $this->sqlGetChannelMap();
		$this->users = $this->sqlGetUsers();

		$this->loggedin_user_fullname          = $_COOKIE['loggedin_user_fullname'];
		$this->xml_logout_url                  = $_COOKIE['xml_logout_url'];
		$this->loggedin_user_id                = $_COOKIE['loggedin_user_id'];
	    
		$this->setConfig('logoutData', false, htmlspecialchars_decode($this->xml_logout_url));
		if(!$this->isLoggedIn() && !$this->getRequestVar('logout') && (isset($this->loggedin_user_id))) {
			$userData = $this->getValidLoginUserData();
			$this->setUserID($userData['userID']);
			$this->setUserName($userData['userName']);
			$this->setLoginUserName($userData['userName']);
			$this->setUserRole($userData['userRole']);
			$this->setRequestVar('login', true);
        	}
	}
	
	// Initialize custom request variables:
	function initCustomRequestVars() {
		// Auto-login phpBB users:
		if(!$this->getRequestVar('logout') && (isset($this->loggedin_user_id))) {
			$this->setRequestVar('login', true);
		}
	}

	// Store the channels the current user has access to
	// Make sure channel names don't contain any whitespace
	function &getChannels() {
		if($this->_channels === null) {
			$this->_channels = array();
			
			$customUsers = $this->getCustomUsers();
			
			// Get the channels, the user has access to:
			if($this->getUserRole() == AJAX_CHAT_GUEST) {
				$validChannels = $customUsers[0]['channels'];
			} else {
				$validChannels = $customUsers[$this->getUserID()]['channels'];
			}

			// Add the valid channels to the channel list (the defaultChannelID is always valid):
			foreach($this->getAllChannels() as $key=>$value) {
				if(!in_array($value, $validChannels)) {
					continue;
				}

				if(in_array($value, $validChannels) || $key == $this->getConfig('defaultChannelID')) {
					$this->_channels[$key] = $value;
				}
			}
		}
		
		return $this->_channels;
	}

	// Store all existing channels
	// Make sure channel names don't contain any whitespace
	function &getAllChannels() {
		if($this->_allChannels === null) {
			// Get all existing channels:
			$customChannels = $this->channels;
			$defaultChannelFound = false;
			
			foreach($customChannels as $key=>$value) {
				$forumName = $this->trimChannelName($value);
				
				$this->_allChannels[$forumName] = $key;
				
				if($key == $this->getConfig('defaultChannelID')) {
					$defaultChannelFound = true;
				}
			}
			
			if(!$defaultChannelFound) {
				// Add the default channel as first array element to the channel list:
				$this->_allChannels = array_merge(
					array(
						$this->trimChannelName($this->getConfig('defaultChannelName'))=>$this->getConfig('defaultChannelID')
					),
					$this->_allChannels
				);
			}
		}
		return $this->_allChannels;
	}

	function &getCustomUsers() {
		$this->users = null;
		$this->users = $this->sqlGetUsers();

		return $this->users;
	}

	function &getCustomChannels() {
		$this->channels = null;
		$this->channels = $this->sqlGetChannels();

		return $this->channels;
	}
	
	function sqlGetChannels()
	{
		$username=$this->bp_config['username'];
		$password=$this->bp_config['password'];
		$database=$this->bp_config['database'];
		$table=$this->bp_config['bp_group_table'];

		mysql_connect($this->bp_config['db'],$username,$password);
		$query="SELECT id, name FROM $database.$table";
		$result=mysql_query($query);

		$num=mysql_numrows($result);

		mysql_close();
		$channels = array();

		$i=0;
		$j=0;
		$channels[$i++] = 'Public';
		$channels[$i++] = 'Private';
		while ($j < $num) {
			$name=mysql_result($result,$j,"name");
			$id=mysql_result($result,$j,"id");
			$channels[$id+$i] = "$name";
			$j++;
		}
		return $channels;
	}

	function sqlGetChannelMap()
	{
		$username=$this->bp_config['username'];
		$password=$this->bp_config['password'];
		$database=$this->bp_config['database'];
		$table=$this->bp_config['bp_group_table'];

		mysql_connect($this->bp_config['db'],$username,$password);
		$query="SELECT id, name FROM $database.$table";
		$result=mysql_query($query);

		$num=mysql_numrows($result);

		mysql_close();
		$channels = array();

		$i=0;
		$j=0;
		$channels['Public'] = $i++;
		$channels['Private'] = $i++;
		while ($j < $num) {
			$name=mysql_result($result,$j,"name");
			$id=mysql_result($result,$j,"id");
			$channels[$name] = $i + $id;
			$j++;
		}
		return $channels;
	}

	function sqlGetUsers()
	{
		$username=$this->bp_config['username'];
		$password=$this->bp_config['password'];
		$database=$this->bp_config['database'];
		$table=$this->bp_config['wp_users_table'];
		$grouptable=$this->bp_config['bp_groups_members'];
		$groups=$this->bp_config['bp_group_table'];

		mysql_connect($this->bp_config['db'],$username,$password);
		#SELECT DISTINCT group_id, name FROM `wp_bp_groups_members` inner join wp_bp_groups on wp_bp_groups.id = group_id WHERE user_id = '10' AND is_confirmed = '1' AND is_banned = '0' order by name asc
		$query="SELECT ID, user_nicename FROM $database.$table WHERE spam = '0' and deleted = '0' order by user_nicename asc";
		$result=mysql_query($query);

		$num=mysql_numrows($result);

		$i=0;
		$j=1;
		// Default guest user (don't delete this one):
		$users[0] = array();
		$users[0]['userRole'] = AJAX_CHAT_GUEST;
		$users[0]['userName'] = null;
		$users[0]['password'] = null;
		$users[0]['channels'] = array(0);
		$users[0]['userID']   = '0';
		$users[0]['profile']  = '';
		while ($i < $num) {
			$user_nicename=mysql_result($result,$i,"user_nicename");
			$id=mysql_result($result,$i,"ID");
			$users[$j]['userName'] = "$user_nicename";
			$users[$j]['password'] = "$user_nicename";
			$users[$j]['userID']   = "$j";
			$users[$j]['profile']  = "<a href='/members/$user_nicename/profile'>Profile Url</a>";
			if ($user_nicename == "admin")
			{
				$users[$j]['userRole'] = AJAX_CHAT_ADMIN;
				$users[$j]['channels'] = array();
                $group = 0;

				for ($group; $group < count($this->channels); $group++)
				{
					array_push($users[$j]['channels'], $group);
				}
				$i++;
				$j++;
				continue;
			} else {
				$users[$j]['userRole'] = AJAX_CHAT_USER;
			}
			# This is butt ugly!  
			$query="SELECT DISTINCT group_id, name FROM $database.$grouptable inner join $database.$groups on $database.$groups.id = group_id WHERE user_id = '".$id."' AND $database.$grouptable.is_confirmed = '1' AND is_banned = '0' order by name asc";
			$result2=mysql_query($query);

			$num2=mysql_numrows($result2);
			$k = 0;
			$users[$j]['channels'] = array(0,1);
			while ($k < $num2) {
				$groupid=mysql_result($result2,$k,"group_id")+2; # We add 1 for the public and private channels (0 is the start)
				array_push($users[$j]['channels'], $groupid);
				$k++;
			}
			$j++;
			$i++;
        }
        mysql_close();
		return $users;
	}

	function getLogoutXMLMessage() {
		$xml = '<?xml version="1.0" encoding="UTF-8"?>';
		$xml .= '<root>';
		$xml .= '<infos>';
		$xml .= '<info type="logout">';
		$xml .= '<![CDATA['.urldecode($this->getConfig('logoutData')).']]>';
		$xml .= '</info>';
		$xml .= '</infos>';
		$xml .= '</root>';
		return $xml;
	}	
}
?>
